{    var   : }
{ M }
Unit DE33R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE28RS_p, UTDE12_p;

procedure DE33R(F :Proc_F70; var M :Integer; IORDER :Integer; XN :Real;
                var YN :Array of Real; H :Real; var DF :Array of Real;
                var X :Array of Real; var Y :Array of Real;
                var RS :Array of Real; var RF :Array of Real;
                var R :Array of Real; var IERR :Integer);

implementation

procedure DE33R(F :Proc_F70; var M :Integer; IORDER :Integer; XN :Real;
                var YN :Array of Real; H :Real; var DF :Array of Real;
                var X :Array of Real; var Y :Array of Real;
                var RS :Array of Real; var RF :Array of Real;
                var R :Array of Real; var IERR :Integer);
var
IO,I,J,K,K1,L,J1 :Integer;
R1 :Real;
C :Array [0..9] of Real;
D :Array [0..44] of Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13;
begin
{   DATA  FORTRAN  }
D[0] := 1.0;
D[1] := 1.0;
D[2] := -2.0;
D[3] := 1.0;
D[4] := -3.0;
D[5] := 3.0;
D[6] := 1.0;
D[7] := -4.0;
D[8] := 6.0;
D[9] := -4.0;
D[10] := 1.0;
D[11] := -5.0;
D[12] := 10.0;
D[13] := -10.0;
D[14] := 5.0;
D[15] := 1.0;
D[16] := -6.0;
D[17] := 15.0;
D[18] := -20.0;
D[19] := 15.0;
D[20] := -6.0;
D[21] := 1.0;
D[22] := -7.0;
D[23] := 21.0;
D[24] := -35.0;
D[25] := 35.0;
D[26] := -21.0;
D[27] := 7.0;
D[28] := 1.0;
D[29] := -8.0;
D[30] := 28.0;
D[31] := -56.0;
D[32] := 70.0;
D[33] := -56.0;
D[34] := 28.0;
D[35] := -8.0;
D[36] := 1.0;
D[37] := -9.0;
D[38] := 36.0;
D[39] := -84.0;
D[40] := 126.0;
D[41] := -126.0;
D[42] := 84.0;
D[43] := -36.0;
D[44] := 9.0;
C[0] := 1.0e0;
C[1] := 0.5e0;
C[2] := 0.4166666666666667e0;
C[3] := 0.375e0;
C[4] := 0.3486111111111111e0;
C[5] := 0.3298611111111111e0;
C[6] := 0.3155919312169312e0;
C[7] := 0.3052662037037037e0;
C[8] := 0.2948680004409171e0;
C[9] := 0.1491888503086420e0;
IERR := 0;
IO := IORDER;
if ( IORDER <= 10 ) 
 then goto _1;
IERR := 1;
IO := 10;
_1:
for I:=1 to M do
 begin
  Y[(I-1)+0*M] := YN[I-1];
_2:
 end;
X[0] := XN;
F(X[0],Y[0+0*M],DF[0+0*M],M);
for I:=1 to M do
 begin
  DF[(I-1)+0*M] := DF[(I-1)+0*M]*H;
  RS[I-1] := DF[(I-1)+0*M];
_3:
 end;
if ( IORDER = 1 ) 
 then goto _13;
for K:=2 to IO do
 begin
  X[K-1] := X[K-2]+H;
_4:
 end;
for J:=2 to IO do
 begin
  J1 := J-1;
  for K:=2 to J do
   begin
    K1 := K-1;
    for I:=1 to M do
     begin
      Y[(I-1)+(K-1)*M] := Y[(I-1)+(K1-1)*M];
      for L:=1 to J1 do
       begin
        Y[(I-1)+(K-1)*M] := Y[(I-1)+(K-1)*M]+DF[(I-1)+(L-1)*M]*C[L-1];
_5:
       end;
_6:
     end;
    F(X[K-1],Y[0+(K-1)*M],RF,M);
    for I:=1 to M do
     begin
      RF[I-1] := RF[I-1]*H;
_7:
     end;
    if ( K = J ) 
     then J1 := J;
    DE28RS(M,J1,RF,DF,R);
_8:
   end;
  for I:=1 to M do
   begin
    for L:=2 to J do
     begin
      R1 := 0.0;
      for K:=L to J do
       begin
        K1 := (J-1)*(J-2) div 2+K-L+1;
        R1 := R1+DF[(I-1)+(K-1)*M]*D[K1-1];
_9:
       end;
      DF[(I-1)+(L-1)*M] := R1;
_10:
     end;
    DF[(I-1)+0*M] := RS[I-1];
_11:
   end;
_12:
 end;
_13:
if ( IERR <> 0 ) 
 then UTDE12(IERR,33);
end;

end.
